// determin.hh
//
// Mical, a regular grammar inference library
// Copyright (C) 2003 Maxime Rey
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.

// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#ifndef MICAL_DETERMIN_HH_
#define MICAL_DETERMIN_HH_

#include <mical/framework/framework_kind.hh>

#include <vaucanson/automata/concept/automata.hh>

#include <mical/framework/partitions/partitions.hh>

namespace mical {

  using namespace vcsn;

  template <class A, class T, class Partition_>
  void 
  proxy_determin(search_kind::pta,
		 Element<A, T>& automaton, 
		 hstate_t state,
		 Partition<Partition_>& partition);

  template <class A, class T, class Partition_>
  void 
  proxy_determin(search_kind::mca,
		 Element<A, T>& automaton, 
		 hstate_t state,
		 Partition<Partition_>& partition);


  template <class A, class T, class Partition_>
  void 
  proxy_determin(search_kind::sup_semi_lattice,
		 Element<A, T>& automaton, 
		 hstate_t state,
		 Partition<Partition_>& partition);

} // mical

#include <mical/framework/determin.hxx>

#endif // MICAL_DETERMIN_HH_
