// make_mca.hh
//
// Mical, a regular grammar inference library
// Copyright (C) 2003 Maxime Rey
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.

// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#ifndef MICAL_MAKE_MCA_HH_
#define MICAL_MAKE_MCA_HH_

#include <vaucanson/fundamental/element.hh>
#include <vaucanson/automata/concept/automata_base.hh>

#include <mical/samples/kind/summary.hh>

namespace mical {

  using namespace vcsn;

  template<typename A, typename T, typename Container_>
  void
  make_mca(Element<A, T>& a, 
	   const FixedSample<Container_,
	   typename Element<A, T>::monoid_elt_t>& sample);
  
  template<typename A, typename T, typename Kind_, typename Container_>
  void
  make_mca(Element<A, T>& a, 
	   const Presentation<Kind_, Container_,
	   typename Element<A, T>::monoid_elt_t>& sample);

} // mical

#include <mical/internal/make_mca.hxx>

#endif // MICAL_MAKE_MCA_HH_
