// get_kernel.hh
//
// Mical, a regular grammar inference library
// Copyright (C) 2003 Maxime Rey
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.

// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#ifndef MICAL_GET_KERNEL_HH_
# define MICAL_GET_KERNEL_HH_

#include <vaucanson/fundamental/element.hh>

#include <mical/samples/kind/summary.hh>

namespace mical {
  
  // Apply on CANONICAL automata of a given language
  // if you wish obtain a correct answer

  using namespace vcsn;

  template <typename A, typename T, typename Container_>
  void 
  get_kernel(const Element<A, T>& a, 
	     FixedSample<Container_,
	     typename Element<A, T>::monoid_elt_t>& res);

  template <typename A, typename T, typename Container_>
  void 
  get_kernel(const Element<A, T>& a, Container_& res);

} // mical 

#include <mical/samples/services/get_kernel.hxx>

#endif // MICAL_GET_KERNEL_HH_
