// get_struct_complete.hh
//
// Mical, a regular grammar inference library
// Copyright (C) 2003 Maxime Rey
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.

// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#ifndef MICAL_GET_STRUCT_COMPLETE_HH_
#define MICAL_GET_STRUCT_COMPLETE_HH_

#include <vaucanson/fundamental/element.hh>
#include <vaucanson/automata/concept/automata.hh>

#include <mical/walkers/info.hh>
#include <mical/walkers/depth_search.hh>

#include <set>
#include <vector>

namespace mical {

  using namespace vcsn;
  using std::set;
  using std::vector;

  template<class A, class T> 
  struct get_sc_sample
  {
    typedef get_sc_sample<A, T>                    self_t;
    
    typedef InfoDepth<A, T, self_t>                info_t;

    typedef typename Element<A, T>::monoid_elt_t   word_t;

    typedef vector<hstate_t>                       delta_state_t;

    get_sc_sample();
    
    template<class Container_>
    void operator ()(Element<A, T> a, Container_& res);
    
    void prefix(info_t& info);

    void infix(info_t& info);

    void postfix(info_t& info);

    template<typename Container_>
    void 
    delta(info_t& info, Container_& res, hstate_t from);

  private:

    set<word_t> container_;

    word_t str;
  };

} // mical 

#include <mical/samples/services/get_struct_complete.hxx>

#endif // MICAL_GET_STRUCT_COMPLETE_HH_
