// info.hxx
//
// Mical, a regular grammar inference library
// Copyright (C) 2003 Maxime Rey
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.

// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#ifndef MICAL_INFO_HXX_
# define MICAL_INFO_HXX_

#include <mical/walkers/info.hh>

namespace mical {

  using std::set;
  using std::deque;

  ////////////////////////////////////////////////////////////////////
  template <class A, class T, class Task_> 
  Info<A, T, Task_>::Info()
  { 
    stop_ = false; 
    first_ = true;
  }

  ////////////////////////////////////////////////////////////////////
  template <class A, class T, class Task_> 
  InfoDepth<A, T, Task_>::InfoDepth() : 
    Info<A, T, Task_>(), nb_cycles_(0)
  {}

  template <class A, class T, class Task_> 
  InfoDepth<A, T, Task_>::InfoDepth(unsigned n) : 
    Info<A, T, Task_>(), nb_cycles_(n)
  {}

  ////////////////////////////////////////////////////////////////////
  template <class A, class T, class Task_>
  InfoBreadth<A, T, Task_>::InfoBreadth() : 
    Info<A, T, Task_>(), nb_cycles_(0)
  {
    count_bis_ = count_ = -1;
  }

  template <class A, class T, class Task_>
  InfoBreadth<A, T, Task_>::InfoBreadth(unsigned n) : 
    Info<A, T, Task_>(), nb_cycles_(n)
  {
    count_bis_ = count_ = -1;
  }
 
  ////////////////////////////////////////////////////////////////////
  template <class A, class T, class Task_, class Order_>
  InfoOrder<A, T, Task_, Order_>::InfoOrder() : 
    Info<A, T, Task_>()
  {}

} // mical

#endif // MICAL_INFO_HXX_
