// security.hxx
//
// Mical, a regular grammar inference library
// Copyright (C) 2003 Maxime Rey
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.

// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#ifndef MICAL_SECURITY_HXX_
# define MICAL_SECURITY_HXX_

#include <mical/walkers/security.hh>

namespace mical {

  namespace security {

    template <class T>
    level<T>::level() : 
      num(1)
    {}

    template <class T>
    level<T>::level(unsigned n) : 
      num(n)
    {}
      
    template <class T>
    unsigned 
    level<T>::get_cycle_number()
    {
      return num;
    }

  } // security

} // mical

#endif // MICAL_SECURITY_HXX_
