// test_find_suffix.cc

#include <vaucanson/fundamental/predefs.hh>
#include <vaucanson/algebra/concrete/free_monoid/predefs.hh>
#include <vaucanson/algebra/concrete/semiring/numerical_semiring.hh>
#include <vaucanson/algebra/concrete/series/polynoms.hh>
#include <vaucanson/tools/usual.hh>

#include <mical/primitives/find_suffix.hh>
#include <mical/primitives/compute_one.hh>


int main(int argc, char** argv)
{
  using namespace std;
  using namespace mical;
  using namespace vcsn;
  using namespace vcsn::algebra;
  using namespace vcsn::algebra::char_letter;

  Alphabet a;

  a.insert('a');
  a.insert('b');
  
  Words free_monoid(a);
  NumericalSemiring ring;
  Series<NumericalSemiring, Words> s(ring, free_monoid);

  typedef Automata auto_t;
  typedef 
    utility::ref< 
    AutomatonImpl<labels_are_series,
    Series<NumericalSemiring, Words>,
    polynom<Word::value_t, bool>,
    ManyLinks<polynom<Word::value_t, bool>, NoTag, NoTag>,
    NoTag,
    map> >
    implem_t;
  
  Element<auto_t, implem_t> A;

  A.create();

  hstate_t n_0 = A.add_state();
  hstate_t n_1 = A.add_state();

  A.set_initial(n_0);

  A.add_letter_edge(n_0, n_0, 'a');
  A.add_letter_edge(n_0, n_1, 'b');
  A.add_letter_edge(n_1, n_0, 'b');
  A.add_letter_edge(n_1, n_1, 'a');

  A.set_final(n_1);


  cout << find_suffix(A, n_0) << endl;
  cout << find_suffix(A, n_1) << endl;
  
  return 0;
}
