(***********************************************************
*                                                          *
*      FUNGI - Fast UNsupervised Grammar Induction         *
*                                                          *
*   Originator: Prachya Boonkwan [1], [2]                  *
*               [1] School of Informatics,                 *
*                   University of Edinburgh, UK            *
*               [2] National Electronics and Computer      *
*                   Technology Center (NECTEC), Thailand   *
*                                                          *
*   Copyright (C) 2011 Prachya Boonkwan                    *
*   <p.boonkwan@sms.ed.ac.uk, kaamanita@hotmail.com>       *
*                                                          *
*   This library is free software; you can redistribute    *
*   it and/or modify it under the terms of the GNU         *
*   Lesser General Public License as published by the      *
*   Free Software Foundation; either version 2.1 of the    *
*   License, or (at your option) any later version.        *
*                                                          *
*   This library is distributed in the hope that it will   *
*   be useful, but WITHOUT ANY WARRANTY; without even      *
*   the implied warranty of MERCHANTABILITY or FITNESS     *
*   FOR A PARTICULAR PURPOSE.  See the GNU Lesser          *
*   General Public License for more details.               *
*                                                          *
*   You should have received a copy of the GNU Lesser      *
*   General Public License along with this library; if     *
*   not, write to the Free Software Foundation, Inc.,      *
*   59 Temple Place, Suite 330, Boston, MA  02111-1307     *
*   USA.                                                   *
*                                                          *
***********************************************************)

module ParserRunner :
  sig
    type syncat_t = Cg.Syncat.t
    type t
    val create : 
        string -> string -> string list -> syncat_t -> 
        string list -> string list -> t
    val tryparse_elt :
      Cky.CKY.dict_t -> Cky.CKY.word_t list -> 
      Dict.Dict.enumlevel_t -> syncat_t -> 
      Dep.DepStruct.t option ->
      Cky.CKY.chart_t * bool
    val tryparse :
      Cky.CKY.dict_t ->
      Cky.CKY.word_t list ->
      Dict.Dict.enumlevel_t list -> syncat_t ->
      Dep.DepStruct.t option ->
      Cky.CKY.chart_t option * Dict.Dict.enumlevel_t * bool ->
      Cky.CKY.chart_t option * Dict.Dict.enumlevel_t * bool
    val list_enumlevels : Dict.Dict.enumlevel_t -> Dict.Dict.enumlevel_t list
    val parse :
      Cky.CKY.dict_t ->
      Chartdb.ChartDb.t ->
      Cky.CKY.word_t list -> syncat_t ->
      Dep.DepStruct.t option ->
      bool * Dict.Dict.enumlevel_t * Chart.Chart.t
    val parse_file : 
      Cky.CKY.dict_t -> Chartdb.ChartDb.t -> syncat_t -> string -> 
      Dep.DepStruct.t array option ->
      unit
    val run : t -> unit
    val compute : 
      string -> string -> string list -> syncat_t -> 
      string list -> string list -> unit
  end
