val set_goldmodel : Deriv.DerivGenModel.t -> unit

type fn_scale_prob_t = int -> float -> float

val structanneal : int -> int -> int -> float -> float

type anneal_t = 
    StandardSampling
  | StructAnneal of int

module Sampler :
sig
    type syncat_t = Cg.Syncat.t
    type word_t = string
    type chart_t = Chart.Chart.t
    type genmodel_t = Deriv.DerivGenModel.t
    type deriv_t = Deriv.Deriv.t
    type span_t = Chart.Chart.span_t
    type dtrargs_t = Chart.Chart.dtrargs_t
    type tree_t = Tree.Tree.t
    type fn_get_chart_t = int -> chart_t
    exception Server_not_found
    type server_t
    val server : JoinHelper.configuration -> unit -> server_t
    type t
    val create :
      int -> int -> float -> 
      genmodel_t -> (syncat_t -> float) -> 
      syncat_t -> fn_get_chart_t -> int -> Hmm.fwdbwd_t ->
      t
    val set_server : t -> server_t option -> unit
    val get_round : t -> int
    val reset_round : t -> unit
    val set_scale_prob : t -> fn_scale_prob_t -> unit
    val compute_onernd_client : unit -> unit
    val run : t -> unit
    val compute :
      ?svr : server_t option ->
      ?scale_prob : fn_scale_prob_t ->
      int -> int -> float ->
      genmodel_t -> (syncat_t -> float) ->
      syncat_t -> fn_get_chart_t -> int -> Hmm.fwdbwd_t ->
      (tree_t * float) list
end
