(***********************************************************
*                                                          *
*      FUNGI - Fast UNsupervised Grammar Induction         *
*                                                          *
*   Originator: Prachya Boonkwan [1], [2]                  *
*               [1] School of Informatics,                 *
*                   University of Edinburgh, UK            *
*               [2] National Electronics and Computer      *
*                   Technology Center (NECTEC), Thailand   *
*                                                          *
*   Copyright (C) 2011 Prachya Boonkwan                    *
*   <p.boonkwan@sms.ed.ac.uk, kaamanita@hotmail.com>       *
*                                                          *
*   This library is free software; you can redistribute    *
*   it and/or modify it under the terms of the GNU         *
*   Lesser General Public License as published by the      *
*   Free Software Foundation; either version 2.1 of the    *
*   License, or (at your option) any later version.        *
*                                                          *
*   This library is distributed in the hope that it will   *
*   be useful, but WITHOUT ANY WARRANTY; without even      *
*   the implied warranty of MERCHANTABILITY or FITNESS     *
*   FOR A PARTICULAR PURPOSE.  See the GNU Lesser          *
*   General Public License for more details.               *
*                                                          *
*   You should have received a copy of the GNU Lesser      *
*   General Public License along with this library; if     *
*   not, write to the Free Software Foundation, Inc.,      *
*   59 Temple Place, Suite 330, Boston, MA  02111-1307     *
*   USA.                                                   *
*                                                          *
***********************************************************)

open Dict
open Dictloader

open Printf

let showdict fname =
    printf "Dictionary: %s\n\n" fname;
    let dict = DictLoader.load fname true in
    printf "%s\n" (Dict.to_string dict)

let main =
    Utils.print_version ();
    let fnames = ref [] in
    let args = []
    and fn_anon = (fun f -> fnames := !fnames @ [f])
    and usagemsg = 
        "Load the dictionary from the specified files and display the result of each one.\n\n"
        ^ (sprintf "Usage: %s dict1 dict2 ..." Sys.argv.(0)) in
    Arg.parse args fn_anon usagemsg;
    List.iter showdict !fnames
