% [Authors]: Hemerson Pistori, Hasan Ibne Akram, Huang Xiao
% [Institute]: Munich University of Technology
%              Dom Bosco Catholic University
% [Web]: http://code.google.com/p/gitoolbox/
% [Emails]: hasan.akram@sec.in.tum.de, huang.xiao@mytum.de
% Copyright ? 2010
% 
% ****** This is a beta version ******
% [DISCLAIMER OF WARRANTY]
% This source code is provided "as is" and without warranties
% as to performance or merchantability. The author and/or 
% distributors of this source code may have made statements 
% about this source code. Any such statements do not constitute 
% warranties and shall not be relied on by the user in deciding
% whether to use this source code.
% 
% This source code is provided without any express or implied
% warranties whatsoever. Because of the diversity of conditions
% and hardware under which this source code may be used, no
% warranty of fitness for a particular purpose is offered. The 
% user is advised to test the source code thoroughly before relying
% on it. The user must assume the entire risk of using the source code.
% 
% -------------------------------------------------
% [Description]
% This function returns a distance from string to be accepted. The
% distance is also saved to disk to be read by external software 
% 
% Input: 'string_value' which is the string to be tested
%        'dfa' defines a DFA
% Output: if returns non-zero, that means string is not accepted 
%            without error correcting. 
%         if returns 0, that means string is accepted (0 distance)

function errors = DistanceToAccept(string_value, dfa)
    %initial state
    state = dfa.InitialState;
    errors = 0;

    for i = 1:length(string_value)  

        if(ismember(string_value(i),dfa.Alphabets))
           string_value(i);
           next_state = GetTransitionState(dfa, state, string_value(i));
	
           if (next_state==0) % Found an error and must recover
              errors = errors + 1;			
           else		
              state = next_state;
           end 
        else
            errors = errors + 1;
        end
    end
    
    if(~ismember(state,dfa.FinalAcceptStates)) errors = errors + 1;


end


