% [Authors]: Hasan Ibne Akram, Huang Xiao
% [Institute]: Munich University of Technology
% [Web]: http://code.google.com/p/gitoolbox/
% [Emails]: hasan.akram@sec.in.tum.de, huang.xiao@mytum.de
% Copyright ? 2010
% 
% ****** This is a beta version ******
% [DISCLAIMER OF WARRANTY]
% This source code is provided "as is" and without warranties
% as to performance or merchantability. The author and/or 
% distributors of this source code may have made statements 
% about this source code. Any such statements do not constitute 
% warranties and shall not be relied on by the user in deciding
% whether to use this source code.
% 
% This source code is provided without any express or implied
% warranties whatsoever. Because of the diversity of conditions
% and hardware under which this source code may be used, no
% warranty of fitness for a particular purpose is offered. The 
% user is advised to test the source code thoroughly before relying
% on it. The user must assume the entire risk of using the source code.
% 
% -------------------------------------------------
% [Description]
% RPNI_COMPATIBLE will take a DFA and S- (the set of negative
% samples) as inputes and check if any of the elements of S- is accepted by
% the DFA. It returns 1 if none of the elements of S- is accepted by the
% DFA and 0 otherwise.

function flag = RPNI_COMPATIBLE(dfa, S_negative)
    S_negative = strrep(S_negative, ' ', '');
    for i = 1:length(S_negative)
        if (IsStringAccepted(char(S_negative(i)), dfa) == 1)
            flag = 0;
            return;
        end
    end
    flag = 1;
end