// fission_sup_semi_lattice.hh
//
// Mical, a regular grammar inference library
// Copyright (C) 2003 Maxime Rey
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.

// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#ifndef MICAL_FISSION_SUP_SEMI_LATTICE_HH_
#define MICAL_FISSION_SUP_SEMI_LATTICE_HH_

#include <mical/framework/framework.hh>

namespace mical {

  template <class A, class T, class Partition_>
  void
  proxy_fission(search_kind::sup_semi_lattice, 
		const Element<A, T>& view, 
		Partition<Partition_>& partition, 
		hstate_t lhs, 
		hstate_t rhs);


} // mical

#include <mical/framework/fission_sup_semi_lattice.hxx>

#endif // MICAL_FISSION_SUP_SEMI_LATTICE_HH_
