// next_step.hxx
//
// Mical, a regular grammar inference library
// Copyright (C) 2003 Maxime Rey
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.

// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#ifndef MICAL_NEXT_STEP_HXX_
# define MICAL_NEXT_STEP_HXX_

#include <mical/framework/next_step.hh>

namespace mical {

  template <class Presentation_>
  void
  proxy_next_step(inference_kind::fixed, Presentation_&)
  {}

  template <class Presentation_>
  void
  proxy_next_step(inference_kind::increm, Presentation_& pres)
  {
    pres.next_step();
  }
  
  template <class Presentation_>
  void
  proxy_next_step(inference_kind::semi_increm, Presentation_& pres)
  {
    pres.next_step();
  }

} // mical

#endif // MICAL_NEXT_STEP_HXX_
