// fusion.hh
//
// Mical, a regular grammar inference library
// Copyright (C) 2003 Maxime Rey
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.

// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#ifndef MICAL_FUSION_HH_
# define MICAL_FUSION_HH_

#include <vaucanson/automata/concept/automata_base.hh>
#include <vaucanson/fundamental/element.hh>
#include <vaucanson/tools/usual.hh>

namespace mical {

  using namespace vcsn;

  // rhs is the invariant state after fusion
  template<typename A, typename T>
  void
  fusion(Element<A, T>& a, 
	 hstate_t lhs,
	 hstate_t rhs);
  
  template<typename A, typename T>
  Element<A, T>
  get_fusion(const Element<A, T>& a, 
	     hstate_t lhs,
	     hstate_t rhs);

} // mical

#include <mical/internal/fusion.hxx>

#endif // MICAL_FUSION_HH_
