// order.hxx
//
// Mical, a regular grammar inference library
// Copyright (C) 2003 Maxime Rey
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.

// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#ifndef MICAL_ORDER_HXX_
#define MICAL_ORDER_HXX_

#include <mical/samples/order.hh>

namespace mical {

  namespace standard {

    template <class A, class T>
    bool
    operator < (const Element<FreeMonoid<A>, T>& lhs,
		const Element<FreeMonoid<A>, T>& rhs)
    {
      if (lhs.value().size() < rhs.value().size())
	return true;

      return (lhs.value() < rhs.value());
    }
    
    template <class A, class T>
    bool
    operator > (const Element<FreeMonoid<A>, T>& lhs,
		const Element<FreeMonoid<A>, T>& rhs)
    {
      return (rhs < lhs);
    }

  } // standard

} // mical

#endif // MICAL_ORDER_HXX_
