// get_caracteristic.hh
//
// Mical, a regular grammar inference library
// Copyright (C) 2003 Maxime Rey
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.

// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#ifndef MICAL_GET_CARACTERISTIC_HH_
# define MICAL_GET_CARACTERISTIC_HH_

#include <vaucanson/fundamental/element.hh>

#include <mical/samples/kind/summary.hh>

namespace mical {

  using namespace vcsn;
  
  template<class A, class T, class Kind_, class Container_>
  void
  get_caracteristic(const Element<A, T>& a,
		    Presentation<Kind_, Container_, 
		    typename Element<A, T>::monoid_elt_t>& pres);

} // mical

#include <mical/samples/services/get_caracteristic.hxx>

#endif // MICAL_GET_CARACTERISTIC_HH_
