// get_struct_complete.hxx
//
// Mical, a regular grammar inference library
// Copyright (C) 2003 Maxime Rey
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.

// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#ifndef MICAL_GET_STRUCT_COMPLETE_HXX_
#define MICAL_GET_STRUCT_COMPLETE_HXX_

#include <mical/samples/services/get_struct_complete.hh>

#include <mical/tools/predefs.hh>
#include <vaucanson/algorithms/trim.hh>

#include <algorithm>

namespace mical {

  using namespace vcsn;
  using std::copy;

  template<class A, class T> 
  get_sc_sample<A, T>::get_sc_sample()
  {}

  template<class A, class T> 
  template<class Container_>
  void
  get_sc_sample<A, T>::operator ()(Element<A, T> a, Container_& res)
  {
    Element<A, T> work = trim(a);
    work.emancipate();

    str = "";

    depth_search(work, *this, security::safe_t(2));
    
    copy(container_.begin(), container_.end(),
	 inserter(res, res.begin()));
  }

  template<class A, class T>
  void 
  get_sc_sample<A, T>::prefix(info_t& info)
  {
    if (!info.first_)
      str = str * info.auto_.label_of(info.edge_).begin()->first;
    
    if (info.auto_.is_final(info.state_))
      container_.insert(str);
  }
  
  template<class A, class T>
  void 
  get_sc_sample<A, T>::infix(info_t& info)
  {
  }
  
  template<class A, class T>
  void 
  get_sc_sample<A, T>::postfix(info_t& info)
  {
    if (str.value().size() > 0)
      str.value().erase(--str.end());
  }

  template<class A, class T>
  template<typename Container_>
  void 
  get_sc_sample<A, T>::delta(info_t& info, Container_& res, hstate_t from)
  {
    info.auto_.deltac(res, from, delta_kind::states());
  }

} // mical 

#endif // MICAL_GET_STRUCT_COMPLETE_HXX_




