// choose.hh
//
// Mical, a regular grammar inference library
// Copyright (C) 2003 Maxime Rey
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.

// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#ifndef MICAL_CHOOSE_HH_
#define MICAL_CHOOSE_HH_

#include <vaucanson/automata/concept/automata_base.hh>

namespace mical {

  using namespace vcsn;

#define RANDOM_VAL(N) \
       ((unsigned) floor(((float) rand() / (float) RAND_MAX) * N))

  template <typename Container_>
  typename Container_::iterator
  choose(const Container_& c);

  template <class A, class T>
  hedge_t
  choose_edge(const Element<A, T>& a, hstate_t state);

} // mical

#include <mical/tools/choose.hxx>

#endif // MICAL_CHOOSE_HH_
