// predefs_states.hh
//
// Mical, a regular grammar inference library
// Copyright (C) 2003 Maxime Rey
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.

// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#ifndef   PREDEFS_STATES_HH_
# define   PREDEFS_STATES_HH_

#include <vaucanson/fundamental/element.hh>
#include <vaucanson/automata/concept/automata.hh>

#include <set>

using namespace vcsn;
using std::set;

namespace mical {

  template <class A, class T>
  void get_min_state(const Element<A, T>& a, hstate_t& res)
  {
    typedef Element<A, T> automaton_t;

    if (a.states().size())
      {
	res = *a.states().begin();
	for (typename automaton_t::state_iterator i = a.states().begin();
	     i != a.states().end(); i++)
	  if (*i < res)
	    res = *i;
      }
  }

  hstate_t max(hstate_t a, hstate_t b)
  {
    if (a < b)
      return b;
    return a;
  }

  hstate_t min(hstate_t a, hstate_t b)
  {
    if (a > b)
      return b;
    return a;
  }

} // mical

#endif /* !PREDEFS_STATES_HH_ */
