// security.hh
//
// Mical, a regular grammar inference library
// Copyright (C) 2003 Maxime Rey
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.

// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#ifndef MICAL_SECURITY_HH_
# define MICAL_SECURITY_HH_

namespace mical {

 namespace security {

    struct responsable
    {
      typedef responsable self_t;
    };

    struct safe
    {
      typedef safe self_t;
    };

    template <class T>
    struct level
    {
      typedef T security_t;

      level();

      level(unsigned n);

      unsigned get_cycle_number();
      
    private:

      unsigned num;
    };
    
    
    typedef level<safe>        safe_t;

    typedef level<responsable> responsable_t;

  } // security

} // mical

#include <mical/walkers/security.hxx>

#endif // MICAL_SECURITY_HH_
