// test_rig.cc

#include <mical/algorithms/give_bs_elt.hh>

#include <vaucanson/algebra/concrete/free_monoid/predefs.hh>
#include <vaucanson/algebra/concrete/semiring/numerical_semiring.hh>
#include <vaucanson/algebra/concrete/series/polynoms.hh>
#include <vaucanson/automata/concept/automata.hh>
#include <vaucanson/tools/usual.hh>

int main(int argc, char** argv)
{
  using namespace std;
  using namespace mical;
  using namespace vcsn;
  using namespace vcsn::algebra;
  using namespace vcsn::algebra::char_letter;

  typedef Automata auto_t;
  typedef 
    utility::ref< 
    AutomatonImpl<labels_are_series,
    Series<NumericalSemiring, Words>,
    polynom<Word::value_t, bool>,
    ManyLinks<polynom<Word::value_t, bool>, NoTag, NoTag>,
    NoTag,
    map> >
    implem_t;

  typedef Element<auto_t, implem_t> automaton_t;

  typedef   FrameWork<
    search_kind::pta, 
    inference_kind::fixed, 
    framework_traits<automaton_t, set<set<hstate_t> >, set<Word>, inference_kind::fixed> > framework_t;

  framework_t fw("toy.d");
  
    automaton_t a = fw.generate();
    a.create();

    SAVE_AUTOMATON_DOT_SIMPLE("before_rig", a);

    give_bs_elt(fw);

    a = fw.generate();
  
    SAVE_AUTOMATON_DOT_SIMPLE("after_rig", a);
    
    return 0;
}
