// test_partitions.cc

#include <vaucanson/automata/concept/automata.hh>

#include <mical/framework/partitions/partitions.hh>

#include <algorithm>

int main(int argc, char** argv)
{
  using namespace std;
  using namespace mical;
  using namespace vcsn;

  // tiny test for partitions

  Partition<partition_traits<set<set<hstate_t> > > > partition;

  set<hstate_t> block1;
  set<hstate_t> block2;

  block1.insert(1);
  block2.insert(2);

  partition.insert(block1);
  partition.insert(block2);

  cout << partition.size() << endl;
	 
  partition.weld(partition.begin(), ++partition.begin());

  cout << partition.size() << endl;

  partition.implose(partition.begin());

  cout << partition.size() << endl;

  partition.weld(partition.begin(), ++partition.begin());

  partition.extract(partition.begin(), block1);

  cout << partition.size() << endl;
  
  return 0;
}
