// set_alphabet.hxx
//
// Vaucanson, a generic library for finite state machines.
// Copyright (C) 2001, 2002 Sakarovitch, Lombardy, Poss, Rey and Regis-Gianas.
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.

// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


#ifndef VCSN_ALGEBRA_SET_ALPHABET_HXX
# define VCSN_ALGEBRA_SET_ALPHABET_HXX

# include <vaucanson/algebra/concrete/alphabets/set_alphabet.hh>

namespace vcsn
{

    /*-----------------------------------------------------------.
    | Definition of an alphabet implementation based on std::set |
    `-----------------------------------------------------------*/
    template<typename L>
    bool op_contains(const AlphabetSet<L>& s, const std::set<L>& a)
    { 
      return true; 
    }

    template<typename L>
    bool op_is_finite(const AlphabetSet<L>& s, const std::set<L>& a)
    { 
      return true; 
    }

    template<typename L>
    bool op_contains_e(const AlphabetSet<L>& s, const std::set<L>& a, 
		       const L& v)
    { 
      return a.find(v) != a.end(); 
    }


} // vcsn

#endif // VCSN_ALGEBRA_SET_ALPHABET_HXX
